function disp(X,varargin)
  assert(isamat(X))
  p = inputParser;
  p.addParamValue('name',inputname(1),@ischar);
  p.addParamValue('selected', [] );
  p.addParamValue('n', 2 );
  p.parse(varargin{:});
  name=p.Results.name;
  selected=p.Results.selected;
  n=p.Results.n;
  if isempty(selected)
    if X.N>2*n
      print_part(X,name,1:n)
      fprintf('  ...\n\n')
      print_part(X,name,X.N-n+1:X.N)
    else  
      print_part(X,name,1:X.N)
    end
    return
  end
  print_part(X,name,selected)
end

function print_part(X,name,selected)
  if isempty(name),name='matrix';end
  n=size(X,2);
  if n>1,getX=@(X,k) X(k);else,getX=@(X,k) X(k).';end
  for k=selected
    fprintf('  %s(%d)=\n',name,k);
    disp(getX(X,k))
  end
end
