function S=gitinfo()
% FUNCTION fc_hypermesh.gitinfo(): returns some informations on the package/toolbox.
%
%    Copyright (C) 2016-2020 F. Cuvelier
%
  S=struct('name','fc-hypermesh', 'tag','1.0.3','commit','c520b34cfd7eb0dbf9e4ecd459fd7162db73cc58','date', '2020-02-16','time','08-34-19','status',0);return; % automatically updated
  rep=fc_hypermesh.path();
  if fc_tools.git.isrepository(rep)
    S=struct('name',  fc_tools.git.get_name(rep), ...
             'tag',   fc_tools.git.get_tag(rep), ...
             'commit',fc_tools.git.get_commit(rep), ...
             'date',  fc_tools.git.get_date(rep), ...
             'time',  fc_tools.git.get_time(rep), ...
             'status',fc_tools.git.isup2date(rep));
  else
    tag='';
    commit='';
    strdate='';
    strtime='';
    S=struct('name','fc-hypermesh','tag',tag,'commit',commit,'date',strdate,'time',strtime,'status',-1);
  end
end
